//-----------------------------------------------------------------
#property copyright "http://www.forex-tsd.com"
#property link      "http://www.forex-tsd.com"
#property  indicator_separate_window
#property  indicator_buffers 3
#property  indicator_color1  LimeGreen
#property  indicator_color2  Gold
#property  indicator_width1  2
//-----------------------------------------------------------------

extern string              TimeFrame   = "0";
extern int                 pq          = 2;
extern int                 pr          = 10;
extern int                 ps          = 5;
extern int                 trigger     = 3;
extern bool   verticalLinesVisible     = false;
extern string verticalLinesID          = "ECCILines";
extern color  verticalLinesUpColor     = LimeGreen;
extern color  verticalLinesDnColor     = Orange;
extern int    verticalLinesStyle       = STYLE_DOT;
extern int    verticalLinesWidth       = 0;
extern bool   alertsOn                 = false;    // Turn alerts on?
extern bool   alertsOnCurrent          = true;     // Alerts on current (still opened) bar?
extern bool   alertsMessage            = true;     // Alerts should show pop-up message?
extern bool   alertsPushNotif          = false;    // Alerts should send push notification?
extern bool   alertsEmail              = false;    // Alerts should send email?
extern bool   alertsSound              = false;    // Alerts should play a sound?
extern bool   Interpolate              = true;
extern bool   ShowHigherTimeFrame      = false;
extern int    NumberTFtojump           =  2; //M15 chart jump 2 to M60 stochastic

double ErgoCCI[];
double MainCCI[];
double trend[];
string indicatorFileName;
bool   returnBars;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
int init()
{
   IndicatorBuffers(3);
   SetIndexBuffer(0,ErgoCCI);   SetIndexLabel(0,"Erg-b0-ergcci TF"+TimeFrame+"");
   SetIndexBuffer(1,MainCCI);   SetIndexLabel(1,"Erg-b1-ergmain");
   SetIndexBuffer(2,trend);     SetIndexLabel(2,"Erg-b2-trend");

      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame == "returnBars"; if (returnBars) return(0);
      if (ShowHigherTimeFrame)
            timeFrame = nextTimeFrame(_Period);
      else  timeFrame = stringToTimeFrame(TimeFrame);
  
   //string shortName = "RK-ml-FX Sniper's Erogodic CCI Trigger lines mtf "+timeFrameToString(timeFrame)+" ("+pq+") ("+pr+") ("+ps+") ("+trigger+")";
        
   //IndicatorShortName(shortName+")");
    return(0);
}
int deinit()
{
   string lookFor       = verticalLinesID+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
   return(0);
}

int start()
{
   string signal;
   int counted_bars = IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { ErgoCCI[0] = limit+1; return(0); }
         if (timeFrame!= Period())
         {
            limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
            for (int i=limit; i>=0; i--)
            {
               int y = iBarShift(NULL,timeFrame,Time[i]);               
                  ErgoCCI[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",pq,pr,ps,trigger,verticalLinesVisible,verticalLinesID,verticalLinesUpColor,verticalLinesDnColor,verticalLinesStyle,verticalLinesWidth,alertsOn,alertsOnCurrent,alertsMessage,alertsPushNotif,alertsEmail,alertsSound,0,y);
                  MainCCI[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",pq,pr,ps,trigger,verticalLinesVisible,verticalLinesID,verticalLinesUpColor,verticalLinesDnColor,verticalLinesStyle,verticalLinesWidth,alertsOn,alertsOnCurrent,alertsMessage,alertsPushNotif,alertsEmail,alertsSound,1,y);
                  trend[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",pq,pr,ps,trigger,verticalLinesVisible,verticalLinesID,verticalLinesUpColor,verticalLinesDnColor,verticalLinesStyle,verticalLinesWidth,alertsOn,alertsOnCurrent,alertsMessage,alertsPushNotif,alertsEmail,alertsSound,2,y);
                  
                  //
                  //
                  //
                  //
                  //
      
                  if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

                  //
                  //
                  //
                  //
                  //

                  datetime time = iTime(NULL,timeFrame,y);
                     for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
                     for(int k = 1; k < n; k++)
                     {
                        ErgoCCI[i+k] = ErgoCCI[i] + (ErgoCCI[i+n]-ErgoCCI[i])*k/n;
                        MainCCI[i+k] = MainCCI[i] + (MainCCI[i+n]-MainCCI[i])*k/n;
                     }
            }
            IndicatorShortName(timeFrameToString(timeFrame)+" FX Sniper's Erogodic CCI w/lines ("+pq+") ("+pr+") ("+ps+") ("+trigger+"): "+signal); 
            return(0);                  
         }

   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--)
   {
      double var1  = iEma(iEma(iEma(        Close[i]-Close[i+1] ,pq,i,0),pr,i,1),ps,i,2);
      double var2  = iEma(iEma(iEma(MathAbs(Close[i]-Close[i+1]),pq,i,3),pr,i,4),ps,i,5);
         if (var2 != 0)
               ErgoCCI[i] = 500.0 * var1/var2;
         else  ErgoCCI[i] = 0;
               MainCCI[i] = iEma(ErgoCCI[i],trigger,i,6);
               trend[i] = trend[i+1];
                  if (MainCCI[i]<ErgoCCI[i]) trend[i] =  1;
                  if (MainCCI[i]>ErgoCCI[i]) trend[i] = -1;
         if (verticalLinesVisible)
         {
            ObjectDelete(verticalLinesID+":u:"+Time[i]);
            ObjectDelete(verticalLinesID+":d:"+Time[i]);
               if (trend[i] != trend[i+1] && trend[i]== 1) drawLine(":u:",i,verticalLinesUpColor);
               if (trend[i] != trend[i+1] && trend[i]==-1) drawLine(":d:",i,verticalLinesDnColor);
         }            
   }
   if (MainCCI[0] >  ErgoCCI[0]) signal = "SHORT";
   if (MainCCI[0] <  ErgoCCI[0]) signal = "LONG";
   if (MainCCI[0] == ErgoCCI[0]) signal = "NEUTRAL";
   IndicatorShortName(timeFrameToString(timeFrame)+ "  FX Sniper's Erogodic CCI w/lines  "+" ("+pq+") ("+pr+") ("+ps+") ("+trigger+"): "+signal); 
      manageAlerts();
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void drawLine(string add, int i,color theColor)
{
   string name = verticalLinesID+add+Time[i];
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_VLINE,0,Time[i],0);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         ObjectSet(name,OBJPROP_STYLE,verticalLinesStyle);
         ObjectSet(name,OBJPROP_WIDTH,verticalLinesWidth);
         ObjectSet(name,OBJPROP_BACK,true);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workEma[][7];
double iEma(double price, double period, int r, int instanceNo=0)
{
   if (ArrayRange(workEma,0)!= Bars) ArrayResize(workEma,Bars); r=Bars-r-1;

   //
   //
   //
   //
   //
      
   double alpha = 2.0 / (1.0+period);
          workEma[r][instanceNo] = workEma[r-1][instanceNo]+alpha*(price-workEma[r-1][instanceNo]);
   return(workEma[r][instanceNo]);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

int stringToTimeFrame(string tfs)
{
   StringToUpper(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}
int nextTimeFrame(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i])
            if ((i+NumberTFtojump)>=ArraySize(iTfTable))
                  return(iTfTable[ArraySize(iTfTable)-1]);
            else  return(iTfTable[i+NumberTFtojump]);
         return(0);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0;
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar]== 1) doAlert(whichBar,"trend changed to up");
         if (trend[whichBar]==-1) doAlert(whichBar,"trend changed to down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message = timeFrameToString(_Period)+" "+Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" FX Snipers Ergodic CCI "+doWhat;
          if (alertsMessage)   Alert(message);
          if (alertsEmail)     SendMail(StringConcatenate(Symbol()," FX Snipers Ergodic CCI "),message);
          if (alertsPushNotif) SendNotification(StringConcatenate(Symbol()," FX Snipers Ergodic CCI "+message));
          if (alertsSound)     PlaySound("alert2.wav");
   }
}